#[doc = "Register `ST3` reader"]
pub struct R(crate::R<ST3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ST3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ST3_SPEC>> for R {
    fn from(reader: crate::R<ST3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ST3` writer"]
pub struct W(crate::W<ST3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ST3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ST3_SPEC>> for W {
    fn from(writer: crate::W<ST3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `ST_0` reader - Status register for UDB\\[n\\]"]
pub struct ST_0_R(crate::FieldReader<u8, u8>);
impl ST_0_R {
    pub(crate) fn new(bits: u8) -> Self {
        ST_0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ST_0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ST_1` reader - Status register for UDB\\[n+1\\]"]
pub struct ST_1_R(crate::FieldReader<u8, u8>);
impl ST_1_R {
    pub(crate) fn new(bits: u8) -> Self {
        ST_1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ST_1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ST_2` reader - Status register for UDB\\[n+2\\]"]
pub struct ST_2_R(crate::FieldReader<u8, u8>);
impl ST_2_R {
    pub(crate) fn new(bits: u8) -> Self {
        ST_2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ST_2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ST_3` reader - Status register for UDB\\[n+3\\]"]
pub struct ST_3_R(crate::FieldReader<u8, u8>);
impl ST_3_R {
    pub(crate) fn new(bits: u8) -> Self {
        ST_3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ST_3_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:7 - Status register for UDB\\[n\\]"]
    #[inline(always)]
    pub fn st_0(&self) -> ST_0_R {
        ST_0_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Status register for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn st_1(&self) -> ST_1_R {
        ST_1_R::new(((self.bits >> 8) & 0xff) as u8)
    }
    #[doc = "Bits 16:23 - Status register for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn st_2(&self) -> ST_2_R {
        ST_2_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:31 - Status register for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn st_3(&self) -> ST_3_R {
        ST_3_R::new(((self.bits >> 24) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Status Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [st3](index.html) module"]
pub struct ST3_SPEC;
impl crate::RegisterSpec for ST3_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [st3::R](R) reader structure"]
impl crate::Readable for ST3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [st3::W](W) writer structure"]
impl crate::Writable for ST3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ST3 to value 0"]
impl crate::Resettable for ST3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
